@echo off
rem #
rem # IBM Confidential
rem # OCO Source Materials
rem # Rational ClearQuest
rem # (C) Copyright IBM Corp. 2010,2013. All Rights Reserved.
rem #
rem # The source code for this program is not published or otherwise
rem # divested of its trade secrets, irrespective of what has been
rem # deposited with the U.S. Copyright Office.
rem #
rem # Run this batch file to copy the Eclipse plugins of the reporting driver from the shared Installation
rem # Manager directory to a target directory
rem # Usage:   
rem #	copyDriverPlugins <no arguments>   - Copies the ClearQuest driver plugins to the current directory
rem #	copyDriverPlugins <targetDirectory> - Copies the ClearQuest driver plugins to the targetDirectory   
rem #	copyDriverPlugins clean - Removes existing ClearQuest driver plugins and jar files.  When this option is used, 
rem #   	the current directory is treated as the targetDirectory. 

setlocal
:start
rem PLUGIN_PATH and EXTRACT_PROGRAM path can be changed if necessary.  Other settings should not be changed.
set PLUGIN_PATH=%CLEARQUEST_HOME%\reports\driver\plugins
set EXTRACT_PROGRAM="%RATIONAL_COMMON%\infozip\unzip"

set CQ_CORE_LIB=com.ibm.rational.clearquest.core.lib
set CQ_JDBC=com.ibm.rational.clearquest.jdbc
set CM_LIBRARY=com.ibm.rational.stp
set ODA_JDBC=com.ibm.rational.clearquest.oda.jdbc_
set ODA_JDBC_NL=com.ibm.rational.clearquest.oda.jdbc.nl1

if "clean" == "%1" goto clean

if [%1]==[] goto setdefault
set TARGET_PATH=%1
set BIRT_PATH=%~1
goto copyPlugins

:setdefault
set TARGET_PATH=.
set BIRT_PATH=%cd%
goto copyPlugins


:clean
set TARGET_PATH=.
if /i (%cd:~-3%)==(lib) goto cleanJ2EE
goto :cleanOSGi


:cleanJ2EE
@echo Removing ClearQuest Reporting Driver JAR
erase stpcmmn.jar
erase stpwvcm.jar
erase stpcq.jar
erase cqjni.jar
erase commons-httpclient-3.0.1.jar
erase com.ibm.rational.clearquest*.jar

@echo Renaming axis.jar.backup back to axis.jar
@echo Renaming org.apache.xml.serializer_version.jar.backup to org.apache.xml.serializer_version.jar
@echo Renaming org.apache.xerces_version.jar to org.apache.xerces_version.jar.backup
rename %TARGET_PATH%\*.jar.backup *.

goto:eof

:cleanOSGi
@echo Removing ClearQuest Reporting Driver plugins

FOR /D /R %cd% %%X IN (%CQ_CORE_LIB%* %CQ_JDBC%* %CM_LIBRARY%* %CQ_JDBC%* %ODA_JDBC_NL%*) DO RD /S /Q "%%X"
del com.ibm.rational.clearquest* /Q

goto:eof

rem Get the newest version of the passed plugin, and copy to the TARGET_PATH
:copyNewest
call :getNewest %1
@echo Copying %PLUGIN_PATH%\%NEWEST_FILE%
if NOT (%NEWEST_FILE%)==() copy %PLUGIN_PATH%\%NEWEST_FILE% %TARGET_PATH%
goto:eof


:copyPlugins
rem Determine if the copy target is \WEB-INF\lib.  If so, assume BIRT deployment uses standard J2EE configuration
if /i (%BIRT_PATH:~-3%)==(lib) goto copyPluginsJ2EE
if /i (%BIRT_PATH:~-4%)==(lib/) goto copyPluginsJ2EE
if /i (%BIRT_PATH:~-4%)==(lib\) goto copyPluginsJ2EE
goto copyPluginsOSGi


:copyPluginsOSGi
@echo Copying ClearQuest Reporting Driver files to OSGi directory %BIRT_PATH%

copy "%PLUGIN_PATH%\%CQ_CORE_LIB%*.jar" %TARGET_PATH%
copy "%PLUGIN_PATH%\%CQ_JDBC%*.jar" %TARGET_PATH%
copy "%PLUGIN_PATH%\%CM_LIBRARY%*.jar" %TARGET_PATH%
copy "%PLUGIN_PATH%\%ODA_JDBC%*.jar" %TARGET_PATH%
copy "%PLUGIN_PATH%\%ODA_JDBC_NL%*.jar" %TARGET_PATH%
goto:eof

:copyPluginsJ2EE
@echo Copying ClearQuest Reporting Driver files to J2EE lib directory %BIRT_PATH%

copy "%RATIONAL_COMMON%\stpcmmn.jar" %TARGET_PATH%
copy "%RATIONAL_COMMON%\stpwvcm.jar" %TARGET_PATH%
copy "%RATIONAL_COMMON%\stpcq.jar" %TARGET_PATH%
copy "%CLEARQUEST_HOME%\cqjni.jar" %TARGET_PATH%

copy "%PLUGIN_PATH%\%CQ_JDBC%*.jar" %TARGET_PATH%
copy "%PLUGIN_PATH%\%ODA_JDBC%*.jar" %TARGET_PATH%
copy "%PLUGIN_PATH%\%ODA_JDBC_NL%*.jar" %TARGET_PATH%

%EXTRACT_PROGRAM% "%PLUGIN_PATH%\%CM_LIBRARY%*.jar" commons-httpclient-3.0.1.jar -d %TARGET_PATH% 

@echo Renaming axis.jar to axis.jar.backup
rename %TARGET_PATH%\axis.jar axis.jar.backup

@echo Renaming org.apache.xml.serializer.jar to org.apache.xml.serializer.jar.backup
set NEWEST_FILE=
call :getNewest %TARGET_PATH%\org.apache.xml.serializer_*.jar
if not (%NEWEST_FILE%)==() rename %TARGET_PATH%\%NEWEST_FILE% %NEWEST_FILE%.backup

@echo Renaming org.apache.xerces_*.jar to org.apache.xerces_*.jar.backup
set NEWEST_FILE=
call :getNewest %TARGET_PATH%\org.apache.xerces_*.jar
if not (%NEWEST_FILE%)==() rename %TARGET_PATH%\%NEWEST_FILE% %NEWEST_FILE%.backup

goto:eof

rem Set variable NEWEST_FILE to the newest version of the passed plugin
:getNewest
FOR /F "delims=" %%I IN ('DIR %1 /B /O:-D') DO set "NEWEST_FILE=%%I"
goto :eof


endlocal
